// Copyright 2001, Jonathan Bachrach.  See file TERMS.

import java.io.*;
import java.util.*;
import antlr.*;

/**
 * Curly enclosed fragments
 * @author  Jonathan Bachrach
 * @author  Keith Playford
 * @version 0.9, 03OCT00
 */
public class BracesFragment extends NestedFragment {
    private void init () {
	left  = "{";
	right = "}";
	templateGeneratorName = "processBraces";
	nestedMatcherName     = "matchBraces";
	partMatcherName       = "matchBodyPart";
	strictPartMatcherName = "matchBodyPartStrict";
    }
    BracesFragment(FragmentList children) { 
	super(children); init(); 
	leftToken  = makeToken(JavaTokenTypes.LCURLY, "{");
	rightToken = makeToken(JavaTokenTypes.RCURLY, "}");
    }
    BracesFragment(Token left, FragmentList children, Token right) {
	super(children); init();
	leftToken  = left;
	rightToken = right;
    }
    public boolean isTerminator () { return true; }
    void pprint(PrettyStream p, int depth, boolean isCode) {
	p.print(left);
	pprintln(p, depth + 1);
	nestedFragments.pprint(p, depth + 1, isCode);
	// pprintln(p, depth);
	p.print(right);
	pprintln(p, depth);
    }
    void lprint(PrettyStream p, int depth, boolean isCode) {
	lprint(p, left, leftToken.getLine(), depth);
	p.print(" ");
	nestedFragments.lprint(p, depth + 1, isCode);
	lseek(p, rightToken.getLine(), depth);
	if (!p.atBeginning) p.print(" ");
	p.print(right);
    }
}

