// Copyright 2001, Jonathan Bachrach.  See file TERMS.

import java.io.*;
import java.util.*;

/**
 * Fragment with multiple inside fragments
 * @author  Jonathan Bachrach
 * @author  Keith Playford
 * @version 0.9, 03OCT00
 */
public abstract class CompoundFragment extends Fragment implements Cloneable {
    String templateGeneratorName = null;
    public abstract void setInsideFragments(FragmentList fragments);
    public FragmentList collectBoundVariables () { 
	Enumeration elts  = getInsideFragments().elements();
	FragmentList vars = FragmentList.fnil;
	while (elts.hasMoreElements()) {
	    Fragment obj = (Fragment)elts.nextElement();
	    vars = (FragmentList)(vars.append(obj.collectBoundVariables()));
	}
	return vars;
    }
    public String toString() { 
	String result     = "";
	Enumeration elts  = getInsideFragments().elements();
	while (elts.hasMoreElements()) {
	    Fragment obj = (Fragment)elts.nextElement();
	    result = result + obj;
	}
	return result;
    }
    public Fragment compileNestedTemplate(int depth, String generatorName) {
	if (generatorName == null)
	    System.out.println("GEN NULL" + this.getClass());
	return Template.processTemplate
	    (FragmentList.fnil
	     .fpush(Template.substituteIdentifier
		    ("Template." + generatorName))
	     .fpush(Template.processParens
		    (FragmentList.fnil.
		     fpush(getInsideFragments().compileTemplate(depth))))
	     .freverse());
    }
    public Fragment compileTemplate(int depth) {
	return compileNestedTemplate(depth, templateGeneratorName);
    }

    public List tokens () { return getInsideFragments().tokens(); }
    void print(PrettyStream p) {getInsideFragments().print(p);}
    void println(PrettyStream p) {getInsideFragments().println(p);}
    void pprint(PrettyStream p, int depth, boolean isCode) {
	getInsideFragments().pprint(p, depth, isCode);
    }
    void pprinte(PrettyStream p, int depth, boolean isLast, boolean isCode) {
	getInsideFragments().pprinte(p, depth, isLast, isCode);
    }
    void lprint(PrettyStream p, int depth, boolean isCode) {
	getInsideFragments().lprint(p, depth, isCode);
    }
    void lprinte(PrettyStream p, int depth, boolean isLast, boolean isCode) {
	getInsideFragments().lprinte(p, depth, isLast, isCode);
    }
}

