// Copyright 2001, Jonathan Bachrach.  See file TERMS.

import java.lang.*;
import java.io.*;
import java.util.*;

/**
 * A pseudo stream for pretty printing and remembering line number and
 * whether output is at beginning of line
 * @author  Jonathan Bachrach
 * @author  Keith Playford
 * @version 0.9, 03OCT00
 */
public class PrettyStream { 
    private int lineNumber     = 1;
    public boolean atBeginning = false;
    public PrintStream out     = null;
    public PrettyStream (PrintStream out) {
	this.out = out;
    }
    public int getLine() {
	return lineNumber;
    }
    public void println () {
	atBeginning = true;
	out.println();
	lineNumber++;
    }
    public void println (String s) {
	atBeginning = true;
	out.println(s);
	lineNumber++;
    }
    public void println (Object x) {
	atBeginning = true;
	out.println(x);
	lineNumber++;
    }
    public void print (String s) {
	atBeginning = atBeginning && s.equals(" ");
	out.print(s);
    }
    public void print (Object s) {
	atBeginning = false;
	out.print(s);
    }
    public void close () {
	out.close();
    }
    /*
    public void write (String s) {
	atBeginning = atBeginning && s.equals(" ");
	out.write(s);
    }
    */
}
